#ifndef CONTROL_H
#define CONTROL_H

#include "common.h"


// global control variables
extern int   mouse_state;
extern int   mouse_button;
extern int   old_x;
extern int   old_y;
extern bool  verbose;
extern float time;


// init calls
int make_menu();


// glut callbacks
void menu_func(int value);
void keyboard_func(unsigned char key, int x, int y);
void special_func(int key, int x, int y);
void mouse_click_func(int button, int state, int x, int y);
void mouse_move_func(int x, int y);
void idle_func();
void visibility_func(int visibility);


// control functions
void menu_adjust_light_prop(float* v, int type);
void menu_help();
void mouse_move_camera(int dx, int dy);
void mouse_zoom_camera(int dx, int dy);
void key_move_robot(int s);
void key_rotate_robot(int s);
void key_rotate_shoulder_theta(int s);
void key_rotate_shoulder_pitch(int s);
void key_rotate_elbow(int s);
void key_rotate_wrist(int s);
void key_rotate_head_theta(int s);
void key_rotate_head_pitch(int s);
void key_viewpoint_toggle();
void key_jump();


#endif // CONTROL_H
