#ifndef LIGHTS_H
#define LIGHTS_H


#include "common.h"


extern float ambient[4];
extern float light0[3][4];
extern float light1[4][4];
extern float light1cutoff;
extern float light2[4][4];
extern float light2cutoff;
extern float light3[4][4];
extern float light3cutoff;
extern float light4[3][4];


enum {
	L_AMBIENT,
	L_POSITION,
	L_DIRECTION,
	L_CUTOFF,
	L_DIFFUSE,
	L_SPECULAR
};


void make_lights();
void place_lights();
void set_ambient_light(float r, float g, float b);
void place_spotlight();
void calc_shadow_matrix(float m[4][4], float p[4], float l[4]);


#endif // LIGHTS_H
