#include "robot.h"

#include <GL/glut.h>
#include <math.h>
#include <iostream.h>
#include "lights.h"
#include "main.h"


//int drawRobot_list;


float robot_body_x		= 0;
float robot_body_y		= 0;
float robot_body_z		= 2;
float robot_body_vel_z		= 0;
float robot_body_theta		= 0;
float robot_head_theta		= 0;
float robot_head_pitch		= 0;
float robot_shoulder_theta	= 0;
float robot_shoulder_pitch	= 0;
float robot_elbow_theta		= 0;
float robot_wrist_theta		= 0;

bool set_spotlight = true;

/*
void initRobotDisplayLists ()
{
  drawRobot_list = glGenLists(ROBOT_D);
  glNewList(drawRobot_list, GL_COMPILE);
  drawRobot();
  glEndList();
}
*/

void drawRobot ()
{
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glTranslatef(robot_body_x, robot_body_y, robot_body_z);
  glRotatef(robot_body_theta, 0, 0, 1);
  glRotatef(-90, 0, 0, 1);

  drawBody();

  glPushMatrix();
      glTranslatef(0, 0, 2.8);
      glRotatef(robot_head_theta, 0, 0, 1);
      glRotatef(robot_head_pitch, 1, 0, 0);
      drawHead();
  glPopMatrix();

  glPopMatrix();
}


void drawBody ()
{
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,
               (float[4]){ 0, 0.1, 0.9, 1 });
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,
               (float[4]){ 0, 0.1, 0.9, 1 });
  glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR,
               (float[4]){ 0, 0.2, 0.7, 1 });
  glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS,
               (float[1]){ 0.9 });

  glutSolidSphere(2, 15, 10);

  glPushMatrix();
      glTranslatef(2, 0, 0);
      glRotatef(robot_shoulder_theta, 1, 0, 0);
      glRotatef(robot_shoulder_pitch, 0, 0, 1);
      drawArm();
  glPopMatrix();
}


void drawArm ()
{
  glutSolidSphere(0.8, 10, 7);

  glPushMatrix();
      glTranslatef(0.4, 1.0, 0);
      glRotatef(robot_elbow_theta, 1, 0, 0);
      glutSolidSphere(0.6, 10, 7);

      glPushMatrix();
          glTranslatef(0, 0.8, 0);
          glutSolidSphere(0.4, 10, 7);

          glRotatef(robot_wrist_theta, 0, 1, 0);

          glPushMatrix();
              glTranslatef(0, 0.4, 0);
              glutSolidSphere(0.1, 8, 7);
          glPopMatrix();
          glPushMatrix();
              glTranslatef(0.2, 0.35, 0);
              glutSolidSphere(0.1, 8, 7);
          glPopMatrix();
          glPushMatrix();
              glTranslatef(-0.2, 0.35, 0);
              glutSolidSphere(0.1, 8, 7);
          glPopMatrix();

      glPopMatrix();
  glPopMatrix();
}


void drawHead ()
{
  glutSolidSphere(1, 10, 8);

  drawEyes();
}


void drawEyes ()
{
  if (set_spotlight)
      place_spotlight();
  else
      glDisable(GL_LIGHT1);

  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,
               (float[4]){ 1, 0, 0, 1 });
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,
               (float[4]){ 0.9, 0.05, 0.05, 1 });
  glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR,
               (float[4]){ 0, 0, 0, 1 });
  glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS,
               (float[1]){ 0.2 });

  glPushMatrix();

  glTranslatef(0.3, 0.7, 0.5);
  glutSolidSphere(0.3, 10, 8);

  glPopMatrix();
  glPushMatrix();

  glTranslatef(-0.3, 0.7, 0.5);
  glutSolidSphere(0.3, 10, 8);

  glPopMatrix();
}


void myTeapot ()
{
        glPushMatrix();

  
        glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,
                (float[4]){ 1, 1, 1, 1 });
        glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,
                (float[4]){ 1, 1, 1, 1 });
        glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR,
                (float[4]){ 0.7, 0.7, 0.4, 1 });
        glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS,
                (float[1]){ 0.9 });

        glutSolidTeapot(1);

        glPopMatrix();
}
